<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.gxwebsoft.project.mapper.ProjectFieldMapper">

  <!-- 关联查询sql -->
  <sql id="selectSql">
    SELECT a.*, b.avatar AS avatar, b.nickname, c.nickname as updateUserName, c.avatar as updateUserAvatar
    FROM project_field a
    LEFT JOIN gxwebsoft_core.sys_user b ON a.user_id = b.user_id
    LEFT JOIN gxwebsoft_core.sys_user c ON a.update_user_id = c.user_id
    <where>
      <if test="param.id != null">
        AND a.id = #{param.id}
      </if>
      <if test="param.appId != null">
        AND a.app_id = #{param.appId}
      </if>
      <if test="param.name != null">
        AND a.name LIKE CONCAT('%', #{param.name}, '%')
      </if>
      <if test="param.comments != null">
        AND a.comments LIKE CONCAT('%', #{param.comments}, '%')
      </if>
      <if test="param.userId != null">
        AND a.user_id = #{param.userId}
      </if>
      <if test="param.updateUserId != null">
        AND c.update_user_id = #{param.updateUserId}
      </if>
      <if test="param.status != null">
        AND a.status = #{param.status}
      </if>
      <if test="param.sortNumber != null">
        AND a.sort_number = #{param.sortNumber}
      </if>
      <if test="param.createTimeStart != null">
        AND a.create_time &gt;= #{param.createTimeStart}
      </if>
      <if test="param.createTimeEnd != null">
        AND a.create_time &lt;= #{param.createTimeEnd}
      </if>
      <if test="param.keywords != null">
        AND (a.comments LIKE CONCAT('%', #{param.keywords}, '%')
        OR a.name LIKE CONCAT('%', #{param.keywords}, '%')
        )
      </if>
    </where>
  </sql>

  <!-- 分页查询 -->
  <select id="selectPageRel" resultType="com.gxwebsoft.project.entity.ProjectField">
    <include refid="selectSql"></include>
  </select>

  <!-- 查询全部 -->
  <select id="selectListRel" resultType="com.gxwebsoft.project.entity.ProjectField">
    <include refid="selectSql"></include>
  </select>

</mapper>
